/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.baseprogramming.dev;

import com.baseprogramming.lang.USCensusNameRecord;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author benitez
 */
public final class FileUtil
{
  public final static String LAST_NAMES="/dist.all.last";
  public final static String FEMALE_NAMES="/dist.female.first";
  public final static String MALE_NAMES="/dist.male.first";
  
  
  public static List<USCensusNameRecord> readUSCensusNameFile(String name) 
          throws IOException
  {
    List<USCensusNameRecord> records= new ArrayList<USCensusNameRecord>();
    
    InputStream is = null;
    BufferedReader br = null;
    
    try 
    { 
      is = FileUtil.class.getResourceAsStream(name);
      br = new BufferedReader(new InputStreamReader(is));
      String line=null;
      while (true)
      {
        line=br.readLine();
         if(line==null){break;}
         
          USCensusNameRecord record = USCensusNameRecord.parseFileRecord(line);
          records.add(record);
         
         
      }
    }
   
    finally
    {
        if (br != null) br.close();
        if (is != null) is.close();
    }
    
    return records;
    
    
  }
  
}
