/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.baseprogramming.dev.gen;

import com.baseprogramming.dev.FileUtil;
import com.baseprogramming.lang.USCensusNameRecord;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

/**
 *
 * @author benitez
 */
public final class USCensusNameGenerator
{
  private static List<USCensusNameRecord> FemaleFirstNames = new ArrayList<USCensusNameRecord>();
  private static List<USCensusNameRecord> AllFirstNames = new ArrayList<USCensusNameRecord>();
  private static List<USCensusNameRecord> MaleFirstNames = new ArrayList<USCensusNameRecord>();
  private static List<USCensusNameRecord> LastNames = new ArrayList<USCensusNameRecord>();
  
  private USCensusNameGenerator(){}
  
  public static void loadAllNameLists()
  {
    loadList(FileUtil.MALE_NAMES);
    loadList(FileUtil.FEMALE_NAMES);
    loadList(FileUtil.LAST_NAMES);
    
  }
  
  public static String getRandomLastName()
  {
    if(LastNames==null)
    {
      LastNames=loadList(FileUtil.LAST_NAMES);
    }
    
    return getRandomListItem(LastNames);
    
  }
  
  public static String getRandomFemaleFirstName()
  {
    if(FemaleFirstNames.isEmpty())
    {
      FemaleFirstNames=loadList(FileUtil.FEMALE_NAMES);
      if(AllFirstNames==null)
      {
        AllFirstNames= new ArrayList<USCensusNameRecord>();
      }
      AllFirstNames.addAll(FemaleFirstNames);
    }
    
    return getRandomListItem(FemaleFirstNames);
    
  }
  
  public static String getRandomMaleFirstName()
  {
    if(MaleFirstNames==null)
    {
      MaleFirstNames=loadList(FileUtil.MALE_NAMES);
      if(AllFirstNames==null)
      {
        AllFirstNames= new ArrayList<USCensusNameRecord>();
      }
      AllFirstNames.addAll(MaleFirstNames);
    }
    
    return getRandomListItem(MaleFirstNames);
    
  }
  
  public static String getRandomAnyGenderFirstName()
  {
    
    if(MaleFirstNames.isEmpty())
    {
      MaleFirstNames=loadList(FileUtil.MALE_NAMES);
      if(AllFirstNames.isEmpty())
      {
        AllFirstNames= new ArrayList<USCensusNameRecord>();
      }
      AllFirstNames.addAll(MaleFirstNames);
    }
    
    if(FemaleFirstNames.isEmpty())
    {
      FemaleFirstNames=loadList(FileUtil.FEMALE_NAMES);
      if(AllFirstNames.isEmpty())
      {
        AllFirstNames= new ArrayList<USCensusNameRecord>();
      }
      AllFirstNames.addAll(FemaleFirstNames);
    }
    
    return getRandomListItem(AllFirstNames);
    
  }
  
  
  private static String getRandomListItem(List<USCensusNameRecord> list)
  {
    Random rand= new Random();
    int index=rand.nextInt(list.size());
    
    return list.get(index).getName();
  }
  
  private static List<USCensusNameRecord> loadList(String name)
  {
    try
    {
      return FileUtil.readUSCensusNameFile(name);
    }
    catch(Exception e)
    {
      String msg=String.format("Unable to read name file (%s): %s",name,e.getMessage());
      throw new java.lang.RuntimeException(msg);
    }
  }
  
  
}
