/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.baseprogramming.dev.gen.ui;

import com.baseprogramming.dev.gen.DataFactory;
import com.baseprogramming.lang.WordCategory;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;


/**
 *
 * @author benitez
 */
public class JavLibBuilder extends javax.swing.JFrame
    implements ActionListener //,javax.swing.event.MouseInputListener
{
  private JPopupMenu menu;

  /**
   * Creates new form JavLibBuilder
   */
  public JavLibBuilder()
  {
    initComponents();
    createMenu();
    
    setupMouseListener();
  }
  
  private void setupMouseListener()
  {
    //this.jepMarkup.addMouseListener(this);
    this.jepMarkup.addMouseListener(new MouseAdapter()
    {

      @Override
      public void mouseReleased(MouseEvent event)
      {
        if(event.isPopupTrigger())
        {
          menu.show(jepMarkup, event.getX(), event.getY());
        }
      }
      
    });
  }
  
  private void createMenu()
  {
    menu= new JPopupMenu();
    for(WordCategory pos : WordCategory.values())
    {
      WordCategoryMenuItem item= new WordCategoryMenuItem(pos);
      item.addActionListener(this);
      menu.add(item);
    }
  }
  
  
  @Override
  public void actionPerformed(ActionEvent e)
  {
         WordCategoryMenuItem item=(WordCategoryMenuItem)e.getSource();
         int pos= this.jepMarkup.getSelectionStart();
         try
         {
           String var="@{" + item.getPos().name() + "}";
           this.jepMarkup.getDocument().insertString(pos, var, null);
         }
         catch(Exception ex)
         {
           
         }
  }
  
  /**
   * This method is called from within the constructor to initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is always
   * regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane4 = new javax.swing.JScrollPane();
        jepMarkup = new javax.swing.JEditorPane();
        jToolBar1 = new javax.swing.JToolBar();
        jbLoadData = new javax.swing.JButton();
        jbProcessJavLib = new javax.swing.JButton();
        jScrollPane5 = new javax.swing.JScrollPane();
        jepProcessed = new javax.swing.JEditorPane();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Jav Lib Builder");

        jepMarkup.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jepMarkupMousePressed(evt);
            }
        });
        jScrollPane4.setViewportView(jepMarkup);

        jToolBar1.setRollover(true);

        jbLoadData.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/baseprogramming/dev/gen/ui/database_refresh.png"))); // NOI18N
        jbLoadData.setToolTipText("Refresh Data");
        jbLoadData.setFocusable(false);
        jbLoadData.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jbLoadData.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jbLoadData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbLoadDataActionPerformed(evt);
            }
        });
        jToolBar1.add(jbLoadData);

        jbProcessJavLib.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/baseprogramming/dev/gen/ui/page_gear.png"))); // NOI18N
        jbProcessJavLib.setToolTipText("Process Jav Lib");
        jbProcessJavLib.setFocusable(false);
        jbProcessJavLib.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jbProcessJavLib.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jbProcessJavLib.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbProcessJavLibActionPerformed(evt);
            }
        });
        jToolBar1.add(jbProcessJavLib);

        jepProcessed.setEditable(false);
        jScrollPane5.setViewportView(jepProcessed);

        jLabel1.setText("Create Jav Lib Definition");

        jLabel2.setText("Processed Jav Lib Text");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jToolBar1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2)
                            .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(0, 354, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane5, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                            .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                        .addContainerGap())))
            .addGroup(layout.createSequentialGroup()
                .addComponent(jSeparator1)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(jToolBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 153, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

  private void jepMarkupMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jepMarkupMousePressed
    
    //System.out.println(this.jepMarkup.getSelectionStart());
    
  }//GEN-LAST:event_jepMarkupMousePressed

  private void jbProcessJavLibActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbProcessJavLibActionPerformed
    
    String raw=this.jepMarkup.getText();
    if(raw==null || raw.isEmpty())
    {
      JOptionPane.showMessageDialog(null, "Please enter text first");
    }
    try
    {
      String text=DataFactory.processJavLib(raw);
      this.jepProcessed.setText(text);
    }
    catch(Exception e)
    {
      JOptionPane.showMessageDialog(null, "Error while processing Jab Lib: " +  e.getMessage());
    }
    
  }//GEN-LAST:event_jbProcessJavLibActionPerformed

  private void jbLoadDataActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbLoadDataActionPerformed
    
    DataFactory.loadAllDefaultData();
    
  }//GEN-LAST:event_jbLoadDataActionPerformed

  /**
   * @param args the command line arguments
   */
  public static void main(String args[]) {
    /*
     * Set the Nimbus look and feel
     */
    //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
     * If Nimbus (introduced in Java SE 6) is not available, stay with the
     * default look and feel. For details see
     * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
     */
    try {
      for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
        if ("Nimbus".equals(info.getName())) {
          javax.swing.UIManager.setLookAndFeel(info.getClassName());
          break;
        }
      }
    } catch (ClassNotFoundException ex) {
      java.util.logging.Logger.getLogger(JavLibBuilder.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    } catch (InstantiationException ex) {
      java.util.logging.Logger.getLogger(JavLibBuilder.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    } catch (IllegalAccessException ex) {
      java.util.logging.Logger.getLogger(JavLibBuilder.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    } catch (javax.swing.UnsupportedLookAndFeelException ex) {
      java.util.logging.Logger.getLogger(JavLibBuilder.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    }
    //</editor-fold>

    /*
     * Create and display the form
     */
    java.awt.EventQueue.invokeLater(new Runnable() {

      public void run() {
        new JavLibBuilder().setVisible(true);
      }
    });
  }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JButton jbLoadData;
    private javax.swing.JButton jbProcessJavLib;
    private javax.swing.JEditorPane jepMarkup;
    private javax.swing.JEditorPane jepProcessed;
    // End of variables declaration//GEN-END:variables
}
