/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.baseprogramming.lang;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 *
 * @author benitez
 */
public class Term
{
  private String word;
  private List<WordCategory> wordCategories = new ArrayList<WordCategory>();

  public Term() {}

  public Term(String word, WordCategory pos)
  {
    this.word = word;
    this.wordCategories.add(pos);
  }

  
  public WordCategory getWordCategory() 
  {
    if(this.wordCategories.isEmpty()){return null;}
    return this.wordCategories.get(0);
  }
  
  public List<WordCategory> getWordCategories()
  {
    return Collections.unmodifiableList(this.wordCategories);
  }
  
  public void setWordCategory(WordCategory pos) 
  {
    wordCategories.clear();
    wordCategories.add(pos);
  }
  
  public void addWordCategory(WordCategory pos)
  {
    wordCategories.add(pos);
  }
  
  public String getWord() {return word;}
  public void setWord(String word) {this.word = word;}

  @Override
  public String toString()
  {
    StringBuilder poss= new StringBuilder();
    for(WordCategory pos : this.wordCategories)
    {
      if(poss.length()>0){poss.append(", ");}
      poss.append(pos.name());
    }
    return "Word{" + "word=" + word + ", category=" + poss.toString() + '}';
  }
  
  
  
  public static Term createFromTabDelimitedString(String string)
  {
    String[] tokens=string.split("\\t");
    if(tokens.length!=2)
    {
      throw new java.lang.IllegalArgumentException("Invalid word string.  String must have two tokens delimited  by a tab");
    }
    
    String word=tokens[0];
    String tmp=tokens[1].replace("|", "");
    if(tmp.length()==1)
    {
      WordCategory pos=WordCategory.forId(tmp);
      return new Term(word,pos);
    }
    else
    {
      Term wrd= new Term();
      wrd.setWord(word);
      for(String pos : tmp.split(""))
      {
        if(pos.isEmpty() || pos.equals("e")){continue;}
        wrd.addWordCategory(WordCategory.forId(pos));
        
      }
      return wrd;
    }
    
    
  }
  
}
