/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.baseprogramming.lang;

import com.baseprogramming.dev.StringUtils;

/**
 *
 * @author benitez
 */
public class USCensusNameRecord
{
  private String Name;
  private double Frequency;
  private double CumulativeFrequency;
  private int Rank;
  
  public  USCensusNameRecord(){}
  public USCensusNameRecord(String name, double freq, double cumFreq,int rank)
  {
    
    Name=name;
    Frequency=freq;
    CumulativeFrequency=cumFreq;
  }

  public double getCumulativeFrequency() {
    return CumulativeFrequency;
  }

  public void setCumulativeFrequency(double CumulativeFrequency) {
    this.CumulativeFrequency = CumulativeFrequency;
  }

  public double getFrequency() {
    return Frequency;
  }

  public void setFrequency(double Frequency) {
    this.Frequency = Frequency;
  }

  public String getName() {
    return Name;
  }

  public void setName(String Name) {
    this.Name = Name;
  }

  public int getRank() {
    return Rank;
  }

  public void setRank(int Rank) {
    this.Rank = Rank;
  }
  
  @Override public String toString()
  {
    return Name + "\t" + (this.Frequency) + "\t" + (this.CumulativeFrequency) + "\t" + (this.Rank);
  }
  
  public static USCensusNameRecord parseFileRecord(String line)
  {
    USCensusNameRecord record = new  USCensusNameRecord();
    
    String name=line.substring(0, 15).trim();
    name=StringUtils.capitalize(name);
    String freq=line.substring(16,21).trim();
    String cumFreq=line.substring(21, 28).trim();
    String rank=line.substring(29).trim();
    
    record.setName(name);
    record.setFrequency(Double.valueOf(freq));
    record.setCumulativeFrequency(Double.valueOf(cumFreq));
    record.setRank(Integer.valueOf(rank));
    
    return record; 
  }
  
}
